#include <iostream>
#include <tuple>

using namespace std;

int mod(int a, int m) {
	if(a < 0)
		return (m - (-a) % m) % m;
	return a % m;
}

int add(int a, int b, int m) {
	return (a + b) % m;
}

int sub(int a, int b, int m) {
	return (m + a - b) % m;
}

int mul(int a, int b, int m) {
	return (a * b) % m;
}

int pow(int a, int b, int m) {
	int res = 1;
	while(b > 0) {
		if(b & 1 == 1)
			res = mul(res, a, m);
		a = mul(a, a, m);
		b >>= 1;
	}
	return res;
}

int euclid(int a, int b, int& x, int& y) {
	int r1 = a, r2 = b;
	int x1 = 1, x2 = 0;
	int y1 = 0, y2 = 1;

	while(r2 > 0) {
		int q = r1 / r2, r = r1 % r2;
		tie(r1, r2) = make_pair(r2, r1 - q * r2);
		tie(x1, x2) = make_pair(x2, x1 - q * x2);
		tie(y1, y2) = make_pair(y2, y1 - q * y2);
	}

	x = x1;
	y = y1;
	return r1;
}

int inv(int a, int m) {
	int x, y;
	int d = euclid(a, m, x, y);
	if(d != 1)
		return -1;
	return mod(x, m);
}

int main() {
	int a, c, m, n, seed;
	cin >> a >> c >> m >> n >> seed;

	cout << add(mul(pow(a, n, m), seed, m), mul(inv(sub(1, a, m), m), mul(sub(1, pow(a, n, m), m), c, m), m), m) << '\n';

	return 0;
}
