#include <iostream>
#include <vector>
#include <numeric>

using namespace std;

vector<int> erathostenes(int n) {
	vector<int> p(n + 1, 1);
	p[0] = p[1] = 0;

	for(int i = 2; i * i <= n; i++)
		if(p[i] == 1)
			for(int j = i * i; j <= n; j += i)
				p[j] = 0;

	return p;
}

int main() {

	int n;
	cin >> n;

	vector<int> p = erathostenes(n);
	partial_sum(p.begin(), p.end(), p.begin());

	int q;
	cin >> q;
	while(q--) {
		int a, b;
		cin >> a >> b;

		cout << p[b] - p[a - 1] << '\n';
	}

	return 0;
}
