#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> erathostenes(int n) {
	vector<int> p(n + 1, 1);
	p[0] = p[1] = 0;

	for(int i = 2; i * i <= n; i++)
		if(p[i] == 1)
			for(int j = i * i; j <= n; j += i)
				p[j] = 0;

	vector<int> ret;
	for(int i = 2; i <= n; i++)
		if(p[i] == 1)
			ret.push_back(i);

	return ret;
}

int main() {

	int n;
	cin >> n;

	vector<int> p = erathostenes(n);

	int q;
	cin >> q;
	while(q--) {
		int a;
		cin >> a;

		auto it = lower_bound(p.begin(), p.end(), a);
		if(it != p.end())
			cout << *it << '\n';
		else
			cout << -1 << '\n';
	}

	return 0;
}
