#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

int velicina(int n) {
	return pow(2, ceil(log2(n)));
}

vector<int> napravi_stablo(vector<int>& niz, int n) {
	vector<int> stablo(2 * n);

	copy(niz.begin(), niz.end(), stablo.begin() + n);
	for(int k = n - 1; k > 0; k--)
		stablo[k] = max(stablo[2 * k], stablo[2 * k + 1]);

	return stablo;
}

int upit(int l, int r, vector<int>& stablo, int n) {
	int najveci = 0;
	for(l += n, r += n; l <= r; l /= 2, r /= 2) {
		if(l % 2 == 1) najveci = max(najveci, stablo[l++]);
		if(r % 2 == 0) najveci = max(najveci, stablo[r--]);
	}
	return najveci;
}

vector<int> erathostenes(int n) {
	vector<int> p(n + 1);

	for(int i = 1; i <= n; i++)
		for(int j = i; j <= n; j += i)
			p[j]++;

	return p;
}

int main() {

	int n;
	cin >> n;

	vector<int> p = erathostenes(n);
	for(int x : p)
		cout << x << ' ';
	cout << '\n';

	int sn = velicina(p.size());
	vector<int> seg = napravi_stablo(p, sn);

	int q;
	cin >> q;
	while(q--) {
		int a, b;
		cin >> a >> b;

		cout << upit(a, b, seg, sn) << '\n';
	}

	return 0;
}
